<?php

namespace xenarabia\OTSOP\XF\Entity;

use XF;
use XF\Mvc\Entity\Entity;

class Post extends XFCP_Post
{
    public function getTotalSignature()
    {

        if ($this->isFirstPost()) {
            return true;
        }


        $options = XF::options();

        if ($options->otsop_act == 2) {
            return true;
        }

        if (in_array($this->User->user_group_id, $options->otsop_usergroup)) {
            return true;
        }

        if (in_array($this->Thread->node_id, $options->otsop_forum)) {
            return true;
        }

        /** @var \XF\Entity\Post $post */
        $totalSignature = XF::finder('XF:ThreadUserPost')
            ->where('thread_id', $this->thread_id)
            ->where('user_id', $this->user_id)
            ->fetchOne();

        if ($totalSignature->post_count >= 1) {
            $disUserSignature =
                XF::finder('XF:Post')
                ->where('thread_id', $this->thread_id)
                ->where('user_id', $this->user_id)
                ->with('User')
                ->order('position', 'ASC')->fetchOne();
            if ($disUserSignature->position == $this->position) {
                return true;
            }
        }

        return false;
    }
}
